import { Client, ClientConfig } from 'pg';
import SqlQuery from '../Queries/SqlQuery';
import CompiledQuery from '../Queries/CompiledQuery';
import DatabaseInterface from './DatabaseInterface';
declare type LogFunction = (query: CompiledQuery) => void;
export default class PgSqlDatabase implements DatabaseInterface {
    private readonly config;
    private readonly logFunction;
    client: Client;
    constructor(config: ClientConfig, logFunction?: LogFunction);
    connect(autoReconnectDelay?: number | null): Promise<void>;
    disconnect(): Promise<void>;
    query(query: SqlQuery): Promise<any[]>;
    migrate(migrations: {
        [key: string]: SqlQuery;
    }): Promise<void>;
}
export {};
